/**
 * Extiende la clase {@link Buscador Buscador} implementando el algoritmo de busqueda BinarySearch
 * @author Nelson Lopez C., Jaime Stockle O.
 */

public class BinarySearcher extends Buscador {
    /**
     * Busca en un arreglo de objetos Comparable utilizando algoritmo de busqueda BinarySearch.
     * @param A Arreglo donde buscar.
     * @param obj Objeto a buscar.
     * @return indice del objeto encontrado.
     */
    public int buscar(Object[] A, Object obj){
        Estudiante E = (Estudiante) obj;
        int low = 0;
        int high = A.length - 1;
        int mid;
        
        while( low <= high )   {
            mid = ( low + high ) / 2;
            if(((Estudiante)A[mid]).compareTo(E)<0){
                low = mid + 1;
                nc++;
            }
            else if(((Estudiante)A[mid]).compareTo(E)>0 ){
                high = mid - 1;
                nc++;
            }
            else
                return mid;
        }
        return -1;
    }
    /**
     * Obtiene numero de comparaciones.
     * @return numero de comparaciones.
     */
    public int getNumComparaciones(){
        return nc;
    }
    private int nc;
}
