/**
 * Extiende la clase {@link Ordenador Ordenador} implementando el algoritmo de ordenamiento BubbleSort.
 * @author Nelson Lopez C., Jaime Stockle O.
 */

public class BubbleSorter extends Ordenador{
    /** 
     * Ordena un arreglo de objetos Comparable utilizando algoritmo de busqueda BubbleSort.
     * @param A Arreglo de objetos comparables.
     */    
    public void ordenar(Comparable[] A){     
        nc=0;
        ni=0;
        boolean swaper = true;
        while(swaper){
            swaper = false;	
            for(int i = 0; i < A.length - 1; i++){
                nc++;                    
                if(A[i].compareTo(A[i + 1])==1){
                    swaper = true;	
                    ni++;
                    Comparable temp = A[i];		
                    A[i] = A[i + 1];	
                    A[i + 1] = temp;		
                }
            }
        } 
    }
    /**
     * Obtiene numero de comparaciones.
     * @return numero de comparaciones.
     */
    public int getNumComparaciones(){
        return nc;
    }
    /**
     * Obtiene numero de intercambios.
     * @return numero de intercambios.
     */
    public int getNumIntercambios(){
        return ni;
    }
    private int ni;
    private int nc;
}
