/**
 * Clase main para la tarea 1 de Diseno y porgramacion orientada a objetos
 * @author Nelson Lopez C., Jaime Stockle O.
 */

import java.util.*;

public class Tarea1 {
    public static void main(String[] args){
        BubbleSorter BB = new BubbleSorter();
        computarParte1(BB, args[0]);
        InsertionSorter IS =new InsertionSorter();
        computarParte1(IS,args[0]);
        LinearSearcher LS =new LinearSearcher();
        computarParte2(LS);
        BinarySearcher BS =new BinarySearcher();
        computarParte2(BS);
    }
    /**
     * Computa parte 2 de la tarea 1.
     * @param O instancia de tipo Ordenador.
     * @param s nombre del archivo con estudiantes. 
     */
    public static void computarParte1(Ordenador O, String s ){
        LectorEstudiantes lec = new LectorEstudiantes(s);
        est = lec.getEstudiantes();
        System.out.println("\nAlumnos ordenandos con " + O.getClass() + ".");
        O.ordenar(est);
        System.out.println("Numero de Comparaciones = " + O.getNumComparaciones());
        System.out.println("Numero de Intercambios = " + O.getNumIntercambios());
        for (int j = 0; j < est.length; j++)
            System.out.println("[" + j + "] " + est[j].getPromedioPonderado() + "\t" + est[j].getName());
    }
    /**
     * Computa parte 2 de la tarea 1.
     * @param B instancia de tipo Buscador.
     */
    public static void computarParte2(Buscador B){
    
        Random rr = new Random();
        Estudiante E = est[rr.nextInt(est.length)];
        System.out.println("\nAlumno buscado con " + B.getClass() + ".");
        int r = B.buscar(est,E);
        System.out.println("Alumno buscado = " + E.getPromedioPonderado() + "\t" +E.getName());
        System.out.println("Alumno encontrado = " + est[r].getPromedioPonderado() + "\t" +est[r].getName());
        System.out.println("Numero de Comparaciones = " + B.getNumComparaciones());
        
    }
    private static Estudiante[] est;
}
