/**
 * Extiende la clase {@link Ordenador Ordenador} implementando el algoritmo de ordenamiento InsertionSort.
 * @author Nelson Lopez C., Jaime Stockle O.
 */
public class InsertionSorter extends Ordenador{
    /** Ordena un arreglo de objetos Comparable utilizando algoritmo de ordenamiento InsertionSort.
     * @param A Arreglo de objetos comparables.
     */  
    public void ordenar(Comparable[] A){
        nc = 0;
        ni = 0;
        for (int i = 1; i < A.length; i++) {
            Comparable temp = A[i];
            int j;        
            for (j =i-1; j >= 0 && A[j].compareTo(temp)==1; j--, nc++){
                ni++;
                A[j+1] = A[j];
            }
            A[j+1] = temp;
            ni++;
        }
    }
    /**
     * Obtiene numero de comparaciones.
     * @return numero de comparaciones.
     */
    public int getNumComparaciones(){
        return nc;
    }
    /**
     * Obtiene numero de intercambios.
     * @return numero de int6ermacbios.
     */
    public int getNumIntercambios(){
        return ni;
    }
    private int ni;
    private int nc;
}
